.data
S: .space 192
A: .space 48
N: .space 48

str1: .asciiz "Inserisce una stringa \n"
str2: .asciiz "Inserire un numero positivo < %d\n"
str3: .asciiz "S= %d\n"
str4: .asciiz "A[%d]= %d\n"

indstr: .space 8
val1: .space 8
val2: .space 8

;parametri syscall 3
par_syscall3: .word 0      ;lettura da tastiera
ind_syscall3: .space 8
num_syscall3: .word 32

stack: .space 64

.code
iniz_stack:           daddi r29, r0, stack
                      daddi r29, r29, 64
iniz_for1:            daddi r8, r0, 0               ;i=0  per S
                      daddi r9, r0, 0               ;i=0  per N
                      daddi r10, r0, str1
for1:                 sd r10, indstr(r0)
                      daddi r14, r0, indstr
                      syscall 5                     ;printf

                      daddi r11, r8, S
                      sd r11, ind_syscall3(r0)
                      daddi r14, r0, par_syscall3
                      syscall 3
                      
                      sd r1, N(r9)                  ;N[i]=strlen(S[i])
                      daddi r8, r8, 32
                      daddi r9, r9, 8
                      slti r13, r8, 192
                      bne r13, r0, for1

iniz_for2:            daddi r8, r0, 0               ;i=0 (per N)
                      daddi r17, r0, 0              ;i=0 (per S)
                      daddi r9, r0, str2
                      daddi r10, r0, str3
for2:                 ld r11, N(r8)                 ;r11=N(i)
leggi:                sd r9, indstr(r0)
                      sd r11, val1(r0)
                      daddi r14, r0, indstr
                      syscall 5                     ;printf
                      
                      jal input_unsigned
                      dadd r13, r0, r1              ;r13=j=numero positivo inserito
                      slt r15, r13, r11             ; j<N(i) r15=1, else r15=0
                      beq r15, r0, leggi
                      
                      dadd r16, r17, r13            ; r16= i+j
                      sd r10, indstr(r0)
                      lb r15, S(r16)
                      sb r15, val1(r0)
                      daddi r14, r0, indstr
                      syscall 5                     ;printf(""S= %d\n",S[i][j]);
                      
                      dadd r4, r0, r15              ; primo parametro della funzione S[i][j]
                      dadd r5, r0, r11              ; secondo parametro N[i]
                      jal calcola
                      sd r1, A(r8)
                      
                      slt r18, r1, r0
                      bne r18, r0, aggiorna_for
if_interno:           daddi r8, r8, 8
                      daddi r17, r17, 32
aggiorna_for:         slti r19, r17, 192
                      bne r19, r0, for2
                      
iniz_for3:            daddi r8, r0, 0               ;i=0
                      daddi r9, r0, 0               ;indice=0
                      daddi r10, r0, str4
for3:                 sd r10, indstr(r0)
                      sd r9, val1(r0)
                      ld r11, A(r8)
                      sd r11, val2(r0)
                      daddi r14, r0, indstr
                      syscall 5                     ;printf
                      
                      daddi r8, r8, 8
                      daddi r9, r9, 1
                      slti r15, r8, 48
                      bne r15, r0, for3

fine:                 syscall 0

;********************************************************************
calcola:              daddi r29, r29, -24
                      sd r8, 0(r29)
                      sd r9, 8(r29)
                      sd r10, 16(r29)
                      
                      daddi r8, r4, -48             ;r8=t = Sij- 48
                      dsra r10, r5, 1               ;r10=Ni/2
                     
                      slt r9, r8, r5                ;se r8 < r5  vera ovvero se r8 >= r5  falsa
                      bne r9, r0, else_if_c
if_c:                 dsub r1, r8, r10              ;return t-Ni/2
                      j fine_c
                      
else_if_c:            slt r9, r8, r10               ;se r8 < r10 ( t < Ni/2)  vera ovvero se t>= Ni/2  falsa
                      bne r9, r0, else_c
                      dsub r1, r8, r5               ;return t-Ni
                      j fine_c
else_c:               dadd r1, r0, r8               ;return t

fine_c:               ld r8, 0(r29)
                      ld r9, 8(r29)
                      ld r10, 16(r29)    
                      daddi r29, r29, 24
                      
                      jr r31
                      
#include input_unsigned.s
                          
