.data

S: .space 192

A: .space 48
N: .space 48
B: .space 48


stringa1: .asciiz "Inserisce una stringa di soli numeri\n"
stringa2: .asciiz "Stringa errata\n"
stringa3: .asciiz "Inserire un numero positivo \n"
stringa4: .asciiz "A[%d]= %d\n"
stringa5: .asciiz "B[%d]= %d\n"

ind_stringa1: .space 8
indice1: .space 8
par1: .space 8

ind_stringa2: .space 8
indice2: .space 8
par2: .space 8

descrittore: .word 0
ind_buffer: .space 8
dim: .word 32

stack: .space 24

.code

daddi r29,r0,stack		; r29 = indirizzo di stack
daddi r29,r29,24		; r29 = indirizzo di stack + 24

iniz_for1: daddi r2,r0,0	; i=0 per S ( incremento a 32)
	       daddi r3,r0,0	; i=0 per N e A ( incremento ad 8)
	       daddi r8,r0,stringa1
	       sd r8,ind_stringa1(r0)	

for1:	slti r8,r2,192
	beq r8,r0,iniz_for2

	daddi r8,r0,stringa1		;metto in ind_stringa1 l'indirizzo della prima stringa da stampare
	sd r8,ind_stringa1(r0)
	daddi r14,r0,ind_stringa1	;preparo la syscall 5
	syscall 5			; Stampo "Inserisce una stringa di soli numeri\n"	
	
	daddi r8,r2,s			; r8= indirizzo in cui andare a salva la stringa letta
	sd r8,ind_buffer(r0)
	daddi r14,r0,descrittore	; stdin
	syscall 3

	sd r1,n(r3)		; dato che la syscall 3 mette in r1 il numero di caratteri inseriti, metto in N[i]
	
	daddi r4,r2,s		; r4 = *st primo parametro
	ld r5,n(r3)		; r5 = Ni	secondo parametro		
	jal verifica_calcola
	
	sd r1,a(r3)		; salvo in A[i] ci che mi ritorna la funzione.
	
	ld r8,a(r3)		; r8 = A[i]

if:	beq r8,r0,stringa_errata   ; se A[i]==0 salta alla stampa di stringa errata
	
	daddi r2,r2,32
	daddi r3,r3,8
	j for1

stringa_errata: daddi r9,r0,stringa2		; caso in cui la funzione torna 0
	   	        sd r9,ind_stringa1(r0) 		; faccio la stampa di stringa errata e torno al for 
		        daddi r14,r0,ind_stringa1	; senza incrementare le i

		        syscall 5
		        j for1	

iniz_for2: daddi r2,r0,0	; i=0 per A e B
	   daddi r8,r0,stringa3
	   sd r8,ind_stringa1(r0)

for2:	slti r10,r2,48
	beq r10,r0,iniz_for3

	daddi r14,r0,ind_stringa1
	syscall 5	

	jal input_unsigned		; la funzione mi salva in r1 il numero intero che ho inserito
	

				; r1 = num
	ld r8,a(r2)		; r8 = A[i]

	dadd r9,r8,r1		; r9 = A[i] + num
	sd r9,b(r2)		; B[i] = r9

	daddi r2,r2,8
	j for2
	

iniz_for3: daddi r2,r0,0	; i per A e B
	   daddi r3,r0,0	; i come indice
	   daddi r8,r0,stringa4
	   sd r8,ind_stringa1(r0)
	   daddi r8,r0,stringa5
	   sd r8,ind_stringa2(r0)

for3:	slti r10,r3,6
	beq r10,r0,fine
	
	sd r3,indice1(r0)
	ld r8,a(r2)
	sd r8,par1(r0)
	daddi r14,r0,ind_stringa1
	syscall 5

	sd r3,indice2(r0)
	ld r8,b(r2)
	sd r8,par2(r0)
	daddi r14,r0,ind_stringa2
	syscall 5

	daddi r2,r2,8
	daddi r3,r3,1
	j for3

fine: syscall 0


;verifica_calcola
; r4 = *st primo parametro
; r5 = Ni	secondo parametro		

verifica_calcola: daddi r29,r29,-24
		  sd r8,0(r29)
		  sd r2,8(r29)
		  sd r9,16(r29)
		  sd r10,24(r29)

		  daddi r8,r0,0		; r8 = t = 0

iniz_for_funzione: daddi r2,r0,0	; j=0

for_funzione:	slt r10,r2,r5		
		        beq r10,r0,return
		
if_funzione:	dadd r9,r2,r4		;r9 adesso corrisponde all'indirizzo di S pi la j della funzione
		        lb r9,s(r9)		    ;r9 = st[j]
		        slti r10,r9,48
		        beq r10,r0,elseif
		        daddi r1,r0,0		
		        j ripristino

elseif:	        slti r10,r9,58
	            bne r10,r0,else_funzione
	            daddi r1,r0,0			
	            j ripristino

else_funzione: daddi r10,r9,-48	 ; r10 = st[j] - 48
	           dadd r8,r8,r10	 ; r8 = t + st[j] - 48
	       
	           daddi r2,r2,1	 ; i++
	           j for_funzione


return:	       daddi r1,r8,0	; metto in r1 il risultato dell'esecuzione della funzione

ripristino:    ld r8,0(r29)
	           ld r2,8(r29)
	           ld r9,16(r29)
	           ld r10,24(r29)
	           daddi r29,r29,24
	           jr r31

#include input_unsigned.s
