.data

S: .space 200
A: .space 40
B: .space 40
N: .space 40

stringa1: .asciiz "inserire un numero < 10\n"
stringa2: .asciiz "inserisce una stringa con al massimo %d caratteri\n"
stringa3: .asciiz "B[%d]=%d\n"

ind_stringa1: .space 8
val1: .space 8
val2: .space 8


stack: .space 32

parlet: .word 0
indlet: .space 8
numlet: .word 40

.code

init_stack:	daddi r29,r0,stack
			daddi r29,r29,32
			
init_do:	daddi r2,r0,0	;i=0
			
			daddi r8,r0,stringa1
			sd r8,ind_stringa1(r0)
			
do:	        daddi r14,r0,ind_stringa1
            syscall 5
	        jal input_unsigned
	        sb r1,A(r2)
	        dadd r4, r0, r1   ; primo parametro della funzione
	        dadd r5, r0, r2  ; secondo parametro della funzione
	        jal verifica	
	        daddi r2,r1,0
while:      slti r8,r2,40   ; i<5 ?
	        bne r8,r0,do    ; se i <5 riesegue il ciclo do-while
	
init_for1:	daddi r2,r0,0	;i=0 indice di s  che deve essere un multiplo di 40
			daddi r3,r0,0	;i=0 indice di n  che deve essere un multiplo di 8
			
            daddi r8,r0,stringa2 ; inizializza seconda printf
			sd r8,ind_stringa1(r0)
			
for1:	    slti r8,r2,200        ; i < 5 ?
		    beq r8,r0,init_for2   ; se i<5  false => fine ciclo
		    ;printf
            ld r10,A(r3)
		    sd r10,val1(r0)
		    daddi r14,r0,ind_stringa1
		    syscall 5
		    
		    ;gets
		    daddi r8,r2,S
		    sd r8,indlet(r0)
		    daddi r14,r0,parlet
		    syscall 3
		    
		    sd r1,N(r3)        ; r1=N[i]=strlen(S[i])
		    
            daddi r2,r2,40     ; i++ per S
		    daddi r3,r3,8      ; i++ per N
		    j for1
		
init_for2:	daddi r2,r0,0	;i=0 indice di S
			daddi r3,r0,0	;i=0 indice di N
			
for2_1:	  slti r8,r2,200
		  beq r8,r0,init_print     ; se i<5  falsa => fine ciclo esterno
		
		  daddi r9,r0,0	           ;num=0
		  ld r10,N(r3)
		  daddi r4,r0,0	           ;j=0
		
for2_2:	  slt r8,r4,r10
		  beq r8,r0,aggiorna_i     ; se j < N[i]  falsa => fine ciclo interno e aggiornamento di B[i]
		  
		  dadd r5,r2,r4
		  lb r11,S(r5)
		  slti r8,r11,58           ; S[i][j] < 58 ?
		  beq r8,r0,incrementa_j   ; la condizione  falsa => incrementa j senza incrementare num
		  daddi r9,r9,1	           ;num++
incrementa_j:	daddi r4,r4,1      ; j++
				j for2_2
				
aggiorna_i:	sd r9,B(r3)
			daddi r2,r2,40
			daddi r3,r3,8
			j for2_1
			
init_print:	daddi r2,r0,0	;i=0 indice di B
			daddi r3,r0,0	;i=0 indice valore
			daddi r8,r0,stringa3
			sd r8,ind_stringa1(r0)
for_print:	slti r8,r2,40
		   beq r8,r0,fine
		   ld r10,B(r2)
		   sd r3,val1(r0)
		   sd r10,val2(r0)
		   daddi r14,r0,ind_stringa1
		   syscall 5
		   daddi r2,r2,8
		   daddi r3,r3,1
		   j for_print
		
fine: syscall 0

.code
              ; r4=  Ai, r5= i 
verifica:	daddi r29,r29,-8		
			sd r8,0(r29)			
									
			slti r8,r4,10			;	Ai < 10 ?
									
			beq r8,r0,else			
			daddi r1,r5,8			
			j return
else:		daddi r1,r5,0	
return:	    ld r8,0(r29)
		    daddi r29,r29,8
		    jr r31
		
#include input_unsigned.s
